Components.utils.importModule("chrome://phone/content/utils/class.js");

function sink(listeners, property, arguments) {
	for(var i = 0; i < listeners.length; i++) {
		var listener = listeners[i];
		if(listener[property] != null)
			try { listener[property].apply(listener, arguments); }
			catch(e) { }
	}
}

function Phone() { }
var phone = Phone.prototype = new Component("phIPhone");

phone.listeners = [];
phone.headerSink = null;

phone.addProgressListener = function(listener) {
	this.listeners.push(listener);
};
phone.removeProgressListener = function(listener) {
	var listeners = this.listeners;
	for(var i = 0; i < listeners.length; i++)
		if(listeners[i] == listener) delete listeners[i];
};

phone.address = null;

phone._status = "";
phone.status getter = function() {
	return this._status;
};
phone.status setter = function(status) {
	this._status = status;
	sink(this.listeners, "onStatusChange", [this, null, status]);
};

phone._title = "";
phone.title getter = function() {
	return this._title;
};
phone.title setter = function(title) {
	this._title = title;
	sink(this.listeners, "onTitleChange", [this, null, title]);
};

phone.loadAddress = function(address) {
	this.address = address;
	if(this.headerSink != null) this.headerSink.onHeaderChange("To", address.spec);
	this.title = address.displayName;
	this.status = "";
};
phone.loadURI = function(uriSpec) {
	var address = Components.classes["@mozilla.org/phone/address;1"].
		createInstance(Components.interfaces.phIAddress);
	var fixup = Components.classes["@mozilla.org/phone/urifixup;1"].
		getService(Components.interfaces.nsIURIFixup);
	try { var uri = fixup.createFixupURI(uriSpec, 0); }
	catch(e) { throw e; }

	address.uri = uri;
	this.loadAddress(address);
};

var component = new ComponentInfo(
	Phone,
	"Phone",
	"@mozilla.org/phone/phone;1",
	"BFA9216F-C93F-42b2-88BF-839C12B910EB");

var module = new Module(component);
function NSGetModule() { return module; }