Components.utils.importModule("chrome://phone/content/utils/class.js");

function MsgProtocolInfo() { }
var msgProtocolInfo = MsgProtocolInfo.prototype = new Component("nsIMsgProtocolInfo");

msgProtocolInfo.canDelete = true;
msgProtocolInfo.canDuplicate = true;
msgProtocolInfo.canGetIncomingMessages = false;
msgProtocolInfo.canGetMessages = false;
msgProtocolInfo.canLoginAtStartup = true;

msgProtocolInfo._defaultLocalPath = null;
msgProtocolInfo.defaultLocalPath getter = function() {
  var fileSpec = this._defaultLocalPath;
  if(fileSpec == null) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefBranch);
    fileSpec = Components.classes["@mozilla.org/filespec;1"].
      createInstance(Components.interfaces.nsIFileSpec);
    fileSpec.nativePath = prefs.getCharPref("mail.root."+componentType);
  }
  return this._defaultLocalPath = fileSpec;
};
msgProtocolInfo.defaultLocalPath setter = function(fileSpec) {
  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefBranch)
  prefs.setCharPref("mail.root."+componentType, fileSpec.nativePath);
  this._defaultLocalPath = fileSpec;
  return true;
};

msgProtocolInfo.needToBuildSpecialFolderURIs = false;
msgProtocolInfo.preflightPrettyNameWithEmailAddress = true;
msgProtocolInfo.requiresUsername = true;
msgProtocolInfo.serverIID = null; // interface for SIP related properties 
msgProtocolInfo.showComposeMsgLink = false;
msgProtocolInfo.specialFoldersDeletionAllowed = false;

msgProtocolInfo.getDefaultServerPort = function(isSecure) { return isSecure? 5061: 5060; }

var component = new ComponentInfo(
  MsgProtocolInfo,
  "SIP Protocol Info",
  "@mozilla.org/messenger/protocol/info;1?type=sip",
  "CA2B6D28-496A-494c-BD9E-DADC55159CC9");

var module = new Module(component);
function NSGetModule() { return module; }