Components.utils.importModule("chrome://phone/content/utils/class.js");

function SipURI() {
  this.syntaxFactory = Components.classes["@mozilla.org/zap/sipsyntaxfactory;1"].
    getService(Components.interfaces.zapISipSyntaxFactory);
}
var sipURI = SipURI.prototype = new Component("nsIURI", "zapISipSIPURI");
sipURI.extend("zapISipSIPURI");

sipURI.defaultPort getter = function() {
  return this.sips? 5061: 5060;
};

sipURI.spec setter = function(value) {
  try { this.zapISipSIPURI = this.syntaxFactory.deserializeAddress(value).uri; }
  catch(e) { throw "Parse error"; }
};
sipURI.spec getter = function() {
  return this.zapISipSIPURI.serialize();
};

sipURI.path getter = function() {
  return this.zapISipSIPURI.serialize().substring(this.sips? 5: 4);
};

sipURI.userPass getter = function() {
  return this.userinfo;
};
sipURI.userPass setter = function(value) {
  this.userinfo = value;
  return true;
};
sipURI.username getter = function() {
  var userinfo = this.userinfo;
  if(!userinfo) return userinfo;
  var matches = userinfo.split(":");
  return matches[0];
};
sipURI.password getter = function() {
  var userinfo = this.userinfo;
  if(!userinfo) return userinfo;
  var matches = userinfo.split(":");
  return matches.length >= 2? matches[1]: null;
};
sipURI.scheme getter = function() {
  return this.sips? "sips": "sip";
};
sipURI.scheme setter = function(value) {
  vale = value.toLowerCase();
  if(value == "sips") this.sips = true;
  else if(value == "sip") this.sips = false;
  else throw new Error("Invalid protocol scheme");
  return true;
};
sipURI.schemeIs = function(other) {
  var other = other.toLowerCase();
  if(other == "sips" && this.sips) return true;
  if(other == "sip" && !this.sips) return true;
  return false;
};
sipURI.hostPort getter = function() {
  var port = this.port;
  return this.host+(port? ":"+this.port: "");
};

sipURI.equals = function(other) {
  if(!this.schemeIs(other.scheme)) return false;
  try {
    if(this.host.toLowerCase() != other.host.toLowerCase()) return false;
    if(decodeURIComponent(this.userinfo) != decodeURIComponent(other.userinfo)) return false;

    var port = this.port, otherPort = other.port;
    if(!port) port = this.defaultPort;
    if(!otherPort) otherPort = this.defaultPort;
    if(port != otherPort) return false;
    // TODO: compare params and headers
  }
  catch(e) {
    try { return this.path == other.path; }
    catch(e) { return false; }
  }
  return true;
};

sipURI.originCharset = null;

sipURI.QueryInterface = function(iid) {
  throw "LL";
}

var component = new ComponentInfo(
  SipURI,
  "SIP URI",
  "@mozilla.org/phone/sip-uri;1",
  "F7D7D4E6-86D5-481d-A271-94A7A0CBC1B6");

var module = new Module(component);
function NSGetModule() { return module; }
