Components.utils.importModule("chrome://phone/content/utils/class.js");

function SubscribeMCH(userAgent) { this.userAgent = userAgent; }
var subscribeMCH = SubscribeMCH.prototype = new Component("zapISipGenericMCH");
subscribeMCH.authenticate = function(methodClient, request, response) {
  throw "No authentication expected";
};
subscribeMCH.calling = function() {
};
subscribeMCH.finalResponse = function() {
};
subscribeMCH.terminated = function() {
};

function RegisterMCH(userAgent) { this.userAgent = userAgent; }
var registerMCH = RegisterMCH.prototype = new Component("zapISipGenericMCH");

registerMCH.authorized = false;
registerMCH.authenticate = function(methodClient, request, response) {
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].
    getService(Components.interfaces.nsIWindowMediator);
  var window = windowManager.getMostRecentWindow("mail:3pane");

  if(!this.authorized) {
    var authenticator = Components.classes["@mozilla.org/network/sip-authenticator;1"].
      createInstance(Components.interfaces.zapISipAuthenticator);
    authenticator.init(this.userAgent.stack);
    authenticator.generateCredentials(request, response, false, this.userAgent.userName, this.userAgent.password);
    this.authorized = true;
  }
  else {
    if(window) window.alert("Wrong SIP user name or password!");
    this.authorized = false;
    throw "Wrong user data";
  }
};
registerMCH.calling = function() {
};
registerMCH.finalResponse = function(methodClient, response) {
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].
    getService(Components.interfaces.nsIWindowMediator);
  var window = windowManager.getMostRecentWindow("mail:3pane");

  switch(response.statusCode[0]) {
    case '2':
      // XXX this is a hack (a similar thing should be done by a status listener in the future)
      if(window) window.document.getElementById("phoneStatus").setAttribute("online", "true");
      this.userAgent.registered = true;
      break;
    case '4':
      if(window) window.document.getElementById("phoneStatus").removeAttribute("online");
      this.userAgent.registered = false;
      break;
  }
};
registerMCH.terminated = function() {
};

function MSHFactory(userAgent) { this.userAgent = userAgent; }
var mshFactory = MSHFactory.prototype = new Component("zapISipMSHFactory");
mshFactory.createInviteMSH = function() {
  var call = Components.classes["@mozilla.org/phone/call;1?type=server"].
    createInstance(Components.interfaces.phICall);
  call.init(this.userAgent);
  return call.QueryInterface(Components.interfaces.zapISipInviteMSH);
};

function UserAgent() {
  this.stack = Components.classes["@mozilla.org/zap/sipstack;1"].
    createInstance(Components.interfaces.zapISipUAStack);
  this.sdpService = Components.classes["@mozilla.org/zap/sdpservice;1"].
    getService(Components.interfaces.zapISdpService);
}
var userAgent = UserAgent.prototype = new Component("phISipUserAgent", "zapISipInviteMSH");

userAgent.init = function() {
  if(!this.userName || !this.hostName || !this.port) throw "Missing user data";

  this.stack.init(new MSHFactory(this));

  var address = Components.classes["@mozilla.org/phone/address;1"].
    createInstance(Components.interfaces.phIAddress);
  address.spec = "<sip:"+encodeURIComponent(this.userName)+"@"+encodeURIComponent(this.hostName)+":"+this.port+">";
  this.address = address;
};
userAgent.subscribe = function(uri) {
  var toAddress = this.stack.syntaxFactory.deserializeAddress("<"+uri.spec+">"),
    fromAddress = this.stack.syntaxFactory.deserializeAddress(this.address.spec);

  var subscribeMCH = new SubscribeMCH(this);
  var request = this.stack.formulateGenericRequest("SUBSCRIBE", toAddress.uri, toAddress, fromAddress);
  request.appendHeader(this.stack.syntaxFactory.createHeader("Event", "presence"));
  request.appendHeader(this.stack.syntaxFactory.createHeader("Accept", "application/pidf+xml"));
  var subscribeMC = this.stack.createGenericMC(request, subscribeMCH);
//  window.alert(request.serialize());
//  subscribeMC.execute();
  // XXX function not complete yet
};
userAgent.register = function() {
  var address = this.stack.syntaxFactory.deserializeAddress(this.address.spec);

  var registerMCH = new RegisterMCH(this);
  var request = this.stack.formulateRegisterRequest(address);
  var registerMC = this.stack.createGenericMC(request, registerMCH);
  registerMC.execute();
};

userAgent.stack = null;

userAgent.address = null;
userAgent.hostName = null;
userAgent.port = null;
userAgent.userName = null;
userAgent.password = null;

function Manager() {
  var ioService = Components.classes["@mozilla.org/network/io-service;1"].
      getService(Components.interfaces.nsIIOService);
  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefBranch);

  var userAgent = this.defaultClient = Components.classes["@mozilla.org/phone/sip-ua;1"].
    createInstance(Components.interfaces.phISipUserAgent);
  userAgent.userName = prefs.getCharPref("phone.server.realusername");
  userAgent.password = prefs.getCharPref("phone.server.realpassword");
  userAgent.hostName = prefs.getCharPref("phone.server.realhostname");
  userAgent.port = prefs.getIntPref("phone.server.port");
  userAgent.init();
}
var manager = Manager.prototype = new Component("phISipUserAgentManager");

manager.defaultClient = null;

manager.getClient = function(server) {
  if(server == null) {
    return this.defaultClient;
  }
  else {
    return Components.results.NS_ERROR_NOT_IMPLEMENTED;
  }
};

var clientComponent = new ComponentInfo(
  UserAgent,
  "SIP User Agent UserAgent",
  "@mozilla.org/phone/sip-ua;1",
  "98FFE876-8ADF-4364-A9B1-5E10255EB1FE");

var managerComponent = new ComponentInfo(
  Manager,
  "SIP User Agent Manager",
  "@mozilla.org/phone/sip-ua-manager;1",
  "CCC25333-B649-4e49-94FA-F89B7FB038CA");

var module = new Module(clientComponent, managerComponent);
function NSGetModule() { return module; }