Components.utils.importModule("chrome://phone/content/utils/class.js");

var numberExp = /^[+0-9\s*#\/\\\-.()\[\]]*[0-9][0-9a-zA-Z\s+*#\/\\\-.()\[\]]*/;

function PhoneURIFixup() { }
var phoneURIFixup = PhoneURIFixup.prototype = new Component("nsIURIFixup");

phoneURIFixup.createExposableURI = function(uri) {
  return uri;
};

phoneURIFixup.createFixupURI = function(uriText, fixupFlags) {
  if(uriText == null) return false;
  var ioService = Components.classes["@mozilla.org/network/io-service;1"].
    getService(Components.interfaces.nsIIOService);

  uriText = uriText.replace(/^\s+/, "");
  uriText = uriText.replace(/\s+$/, "");

  try {
    var uri = ioService.newURI(encodeURI(uriText), null, null);
    return uri;
  }
  catch(e) { }

  // try matching a phone number
  var match = numberExp(uriText);
  if(match != null && uriText.indexOf('@') < 0) {
    var number = match[0];
    // replace vanity codes
    number = number.replace(/[abcABC]/g, "2");
    number = number.replace(/[defDEF]/g, "3");
    number = number.replace(/[ghiGHI]/g, "4");
    number = number.replace(/[jklJKL]/g, "5");
    number = number.replace(/[mnoMNO]/g, "6");
    number = number.replace(/[p-sP-S]/g, "7");
    number = number.replace(/[tuvTUV]/g, "8");
    number = number.replace(/[w-zW-Z]/g, "9");
    number = number.replace(/[\s\[\]\(\)]/g, "");
    number = number.replace(/\\/g, "/");
    // delete "+" if it isn't at the beginning
    number = number.replace(/(.)\+/g, "$1");
    uriText = "tel:"+number;
    var uri = ioService.newURI(uriText, null, null);
    return uri;
  }
  else {
    try {
      var uri = ioService.newURI("sip:"+encodeURI(uriText), null, null);
      return uri;
    }
    catch(e) { }
  }
  return false;
};

function MailURIFixup() { }
var mailURIFixup = MailURIFixup.prototype = new Component("nsIURIFixup");

mailURIFixup.createExposableURI = function(uri) {
  return uri;
};

mailURIFixup.createFixupURI = function(uriText, fixupFlags) {
  var ioService = Components.classes["@mozilla.org/network/io-service;1"].
    getService(Components.interfaces.nsIIOService);

  uriText = uriText.replace(/^\s+/, "");
  uriText = uriText.replace(/\s+$/, "");
  if(uriText.indexOf("@") < 0) return false;

  try {
    var uri = ioService.newURI(encodeURI(uriText), null, null);
    return uri;
  }
  catch(e) { }

  try {
    var uri = ioService.newURI("mailto:"+encodeURI(uriText), null, null);
    return uri;
  }
  catch(e) { }

  return false;
};

var phoneComponent = new ComponentInfo(
  PhoneURIFixup,
  "Phone URI Fixup",
  "@mozilla.org/phone/phone-urifixup;1",
  "1B1B62A6-0722-4c48-9305-293718B09E1A");

var mailComponent = new ComponentInfo(
  MailURIFixup,
  "Mail URI Fixup",
  "@mozilla.org/phone/mail-urifixup;1",
  "4A099DBB-2EFE-4911-84EE-0277C82AA262");

var module = new Module(phoneComponent, mailComponent);
function NSGetModule() { return module; }