function getDatabaseFromURI(uri) {
  var addressbook = Components.classes["@mozilla.org/addressbook;1"].createInstance(Components.interfaces.nsIAddressBook);
  return addressbook.getAbDatabaseFromURI(uri);
}

function fixupPhoneURI(uriSpec) {
  var fixup = Components.classes["@mozilla.org/phone/phone-urifixup;1"].
    getService(Components.interfaces.nsIURIFixup);
  try { return fixup.createFixupURI(uriSpec, 0); }
  catch(e) { return null; }
}

function generateSIPAddressFromCard(card) {
  var view = GetAbView();
  if(!view) return null;
  var primarySIP = view.directory.getValueForCard(card, "PrimarySIP");
  if(!primarySIP) return null;

  var fixup = Components.classes["@mozilla.org/phone/phone-urifixup;1"].
    getService(Components.interfaces.nsIURIFixup);
  try { var uri = fixup.createFixupURI(primarySIP, 0); }
  catch(e) { return null; }

  var address = Components.classes["@mozilla.org/phone/address;1"].
    createInstance(Components.interfaces.phIAddress);
  address.displayName = card.displayName;
  address.uri = uri;
  return address;
}
